use lavina_core::prelude::Str;
use lavina_core::repo::Storage;
use proto_irc::response::SendResponse;
use std::future::Future;
use tokio::io::AsyncWrite;

pub mod whois;

pub trait Handler {
    fn handle(
        &self,
        server_name: Str,
        client: Str,
        writer: &mut (impl AsyncWrite + Unpin),
        storage: Storage,
    ) -> impl Future<Output = anyhow::Result<()>>;
}
